"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationServiceApplication = void 0;
const tslib_1 = require("tslib");
const rest_1 = require("@loopback/rest");
const loopback4_plus_1 = require("loopback4-plus");
const path = tslib_1.__importStar(require("path"));
const component_1 = require("./component");
const keys_1 = require("./keys");
class AuthenticationServiceApplication extends (0, loopback4_plus_1.IntegrateMixin)(rest_1.RestApplication) {
    constructor(options = {}) {
        super(options);
        this.static('/', path.join(__dirname, '../public'));
        this.bind(keys_1.AuthenticationBindings.CONFIG).to({
            secureClient: true,
        });
        this.component(component_1.AuthenticationServiceComponent);
        this.projectRoot = __dirname;
    }
}
exports.AuthenticationServiceApplication = AuthenticationServiceApplication;
//# sourceMappingURL=application.js.map