"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthServiceBindings = exports.AuthenticationBindings = void 0;
const core_1 = require("@loopback/core");
const core_2 = require("@loopx/core");
var authentication_1 = require("@bleco/authentication");
Object.defineProperty(exports, "AuthenticationBindings", { enumerable: true, get: function () { return authentication_1.AuthenticationBindings; } });
var AuthServiceBindings;
(function (AuthServiceBindings) {
    AuthServiceBindings.COMPONENT = core_1.BindingKey.create(`${core_1.CoreBindings.COMPONENTS}.AuthenticationServiceComponent}`);
    /**
     * Configuration for the authentication service modules
     */
    AuthServiceBindings.Config = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.auth.config`);
    AuthServiceBindings.MfaConfig = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.auth.mfa.config`);
    AuthServiceBindings.OtpConfig = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.auth.mfa.otp.config`);
    AuthServiceBindings.AuthaConfig = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.auth.autha.config`);
    AuthServiceBindings.JWTPayloadProvider = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.auth.jwt.payload`);
    AuthServiceBindings.ForgotPasswordHandler = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.forgetpassword.handler.provider`);
    AuthServiceBindings.ActorIdKey = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.active.users.actorid`);
    AuthServiceBindings.MarkUserActivity = core_1.BindingKey.create(`${core_2.BINDING_PREFIX}.mark.users.activity`);
})(AuthServiceBindings || (exports.AuthServiceBindings = AuthServiceBindings = {}));
//# sourceMappingURL=keys.js.map