import { VerifyFunction } from '@bleco/authentication';
import { Provider } from '@loopback/context';
import { ILogger } from '@loopx/core';
import { AuthClient, User, UserRepository } from '@loopx/user-core';
import { LocalUserProfile } from '../../../models';
import { OtpCacheRepository } from '../../../repositories';
import { OtpService } from '../../../services/otp.service';
import { UserSignupFn } from '../../../types';
export declare class PasswordlessVerifyProvider implements Provider<VerifyFunction.OtpAuthFn> {
    userRepository: UserRepository;
    otpCacheRepo: OtpCacheRepository;
    private readonly client;
    private readonly otpService;
    private readonly signup;
    private readonly logger;
    constructor(userRepository: UserRepository, otpCacheRepo: OtpCacheRepository, client: AuthClient, otpService: OtpService, signup: UserSignupFn<LocalUserProfile, User>, logger: ILogger);
    value(): VerifyFunction.OtpAuthFn;
}
