"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecureClientPasswordVerifyProvider = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const user_core_1 = require("@loopx/user-core");
let SecureClientPasswordVerifyProvider = class SecureClientPasswordVerifyProvider {
    constructor(authClientRepository) {
        this.authClientRepository = authClientRepository;
    }
    value() {
        return async (clientId, clientSecret) => {
            return this.authClientRepository.findOne({
                where: {
                    clientId,
                },
            });
        };
    }
};
exports.SecureClientPasswordVerifyProvider = SecureClientPasswordVerifyProvider;
exports.SecureClientPasswordVerifyProvider = SecureClientPasswordVerifyProvider = tslib_1.__decorate([
    tslib_1.__param(0, (0, repository_1.repository)(user_core_1.AuthClientRepository)),
    tslib_1.__metadata("design:paramtypes", [user_core_1.AuthClientRepository])
], SecureClientPasswordVerifyProvider);
//# sourceMappingURL=secure-client-password-verify.provider.js.map