import { User } from '@loopx/user-core';
import { IOtpRequest, OtpRequestMethod } from '../types';
export type OtpConnectionUserKey = 'phone' | 'email';
export declare const OtpSupportedMethods: OtpRequestMethod[];
export declare const OtpMethodUserKeyMap: Record<OtpRequestMethod, OtpConnectionUserKey>;
export declare class OtpRequest implements IOtpRequest {
    readonly method: OtpRequestMethod;
    readonly contact: string;
    user?: User<import("@loopback/repository").DataObject<import("@loopback/repository").Model>> | undefined;
    readonly contactPropName: string;
    constructor(method: OtpRequestMethod, contact: string, user?: User<import("@loopback/repository").DataObject<import("@loopback/repository").Model>> | undefined);
    static from(contact: string): OtpRequest | undefined;
    static fromUser(user: User, contact: string): OtpRequest;
}
