"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignupBearerVerifyProvider = void 0;
const tslib_1 = require("tslib");
const context_1 = require("@loopback/context");
const core_1 = require("@loopx/core");
const berrors_1 = require("berrors");
const jsonwebtoken_1 = require("jsonwebtoken");
let SignupBearerVerifyProvider = class SignupBearerVerifyProvider {
    constructor(logger) {
        this.logger = logger;
    }
    value() {
        return async (token, req) => {
            let result;
            try {
                result = (0, jsonwebtoken_1.verify)(token, process.env.JWT_SECRET, {
                    issuer: process.env.JWT_ISSUER,
                    algorithms: ['HS256'],
                });
            }
            catch (error) {
                this.logger.error(JSON.stringify(error));
                throw new berrors_1.BErrors.Unauthorized('TokenExpired');
            }
            return result;
        };
    }
};
exports.SignupBearerVerifyProvider = SignupBearerVerifyProvider;
exports.SignupBearerVerifyProvider = SignupBearerVerifyProvider = tslib_1.__decorate([
    tslib_1.__param(0, (0, context_1.inject)(core_1.LOGGER.LOGGER_INJECT)),
    tslib_1.__metadata("design:paramtypes", [Object])
], SignupBearerVerifyProvider);
//# sourceMappingURL=bearer-verify.provider.js.map