"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultRoleProvider = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const user_core_1 = require("@loopx/user-core");
let DefaultRoleProvider = class DefaultRoleProvider {
    constructor(roleRepo) {
        this.roleRepo = roleRepo;
    }
    async value() {
        const tenant = await this.roleRepo.findOne({
            where: { code: user_core_1.DefaultRole.User },
        });
        if (!tenant) {
            throw new Error(`No default type role found. You must seed the database first.`);
        }
        return tenant;
    }
};
exports.DefaultRoleProvider = DefaultRoleProvider;
exports.DefaultRoleProvider = DefaultRoleProvider = tslib_1.__decorate([
    tslib_1.__param(0, (0, repository_1.repository)(user_core_1.RoleRepository)),
    tslib_1.__metadata("design:paramtypes", [user_core_1.RoleRepository])
], DefaultRoleProvider);
//# sourceMappingURL=default-role.provider.js.map