"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultTenantProvider = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const user_common_1 = require("@loopx/user-common");
const user_core_1 = require("@loopx/user-core");
let DefaultTenantProvider = class DefaultTenantProvider {
    constructor(tenantRepository) {
        this.tenantRepository = tenantRepository;
    }
    async value() {
        const tenant = await this.tenantRepository.findOne({ where: { code: user_common_1.DEFAULT_TENANT_CODE } });
        if (!tenant) {
            throw new Error(`Default tenant not found with default code ${user_common_1.DEFAULT_TENANT_CODE}`);
        }
        return tenant;
    }
};
exports.DefaultTenantProvider = DefaultTenantProvider;
exports.DefaultTenantProvider = DefaultTenantProvider = tslib_1.__decorate([
    tslib_1.__param(0, (0, repository_1.repository)(user_core_1.TenantRepository)),
    tslib_1.__metadata("design:paramtypes", [user_core_1.TenantRepository])
], DefaultTenantProvider);
//# sourceMappingURL=default-tenant.provider.js.map