import { Getter } from '@loopback/core';
import { BelongsToAccessor, juggler } from '@loopback/repository';
import { DefaultUserUpdatableCrudRepository, EntityClass, IAuthTenantUser } from '@loopx/core';
import { UserTenant, UserTenantRepository } from '@loopx/user-core';
import { UserLevelResource, UserLevelResourceTypes } from '../models';
export declare class UserLevelResourceRepository<ULR extends UserLevelResourceTypes = UserLevelResourceTypes> extends DefaultUserUpdatableCrudRepository<ULR['Model'], ULR['ID']> {
    protected userTenantRepositoryGetter: Getter<UserTenantRepository>;
    readonly userTenant: BelongsToAccessor<UserTenant, typeof UserLevelResource.prototype.id>;
    constructor(dataSource: juggler.DataSource, userTenantRepositoryGetter: Getter<UserTenantRepository>, getCurrentUser?: Getter<IAuthTenantUser | undefined>, entityClass?: EntityClass<ULR['Model']>);
}
