import { IAuthClient, IAuthUser } from '@bleco/authentication';
import { Provider } from '@loopback/core';
import { ILogger } from '@loopx/core';
import { RoleRepository, TenantConfigRepository, UserLevelPermissionRepository, UserTenantRepository } from '@loopx/user-core';
import { JwtPayloadFn } from './types';
export declare class JwtPayloadProvider implements Provider<JwtPayloadFn> {
    private readonly roleRepo;
    private readonly utPermsRepo;
    private readonly userTenantRepo;
    private readonly tenantConfigRepo;
    private readonly logger;
    constructor(roleRepo: RoleRepository, utPermsRepo: UserLevelPermissionRepository, userTenantRepo: UserTenantRepository, tenantConfigRepo: TenantConfigRepository, logger: ILogger);
    value(): (authUserData: IAuthUser, authClient: IAuthClient, tenantId?: string) => Promise<Object>;
    private _removeUnnecessaryData;
    private _setLocale;
}
